public class RemoteAdder extends java.rmi.server.UnicastRemoteObject implements Adder {
  int sum = 0;
  public RemoteAdder() throws java.rmi.RemoteException {}
  public void add( int a ){ sum += a; }
  public int get(){ return sum; }
  public static void main( String args[] ) throws java.rmi.RemoteException,
                                                  java.net.MalformedURLException {
        System.setSecurityManager(new java.rmi.RMISecurityManager());
	if (args.length > 0) java.rmi.registry.LocateRegistry.createRegistry(1099);
        Adder adder = new RemoteAdder();
        java.rmi.Naming.rebind("Adder", adder);
        System.out.println("Adder is bound");
  }
}
