package client;

import java.rmi.*;
import java.math.*;
import compute.*;

public class ComputePi {
    public static void main(String args[]) throws Exception {
         System.setSecurityManager(new RMISecurityManager());
         Compute compute = (Compute) Naming.lookup("rmi://"+args[0]+":1099/Compute");
         Pi task = new Pi(Integer.parseInt(args[1]));
         BigDecimal pi = (BigDecimal) (compute.executeTask(task));
         System.out.println(pi);
    }    
}
