import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*; 

public class RemoteAdder implements AdderOperations {

    private int num;
    public int sum(){ return num; }
    public void add( int n ){ num += n; }

    public static void main( String[] args ) throws Exception {
       ORB orb = ORB.init(args,null);
       Adder adder = new Adder_Tie(new RemoteAdder());
       orb.connect(adder);
       NamingContext ctx = NamingContextHelper.narrow(orb.resolve_initial_references("NameService"));
       NameComponent[] path = {new NameComponent("Adder","")};
       ctx.rebind(path,adder);
       System.out.println("Adder is bound.");
       System.out.println("Press <Enter> to terminate.");
       System.in.read();
       ctx.unbind(path);
       orb.disconnect(adder);
       orb.destroy();
    }

}
