import org.omg.CORBA.*;
import org.omg.CosNaming.*;

public class RemoteAdder extends _AdderImplBase implements AdderOperations {

    private int num = 0;
    public int sum () { return num; }
    public void add (int n){ num += n; }


    public static void main( String[] args ) throws Exception {
        org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, null);
        RemoteAdder adder = new RemoteAdder();
        orb.connect(adder);
        org.omg.CORBA.Object contextRef = orb.resolve_initial_references("NameService");
        NamingContext ctx = NamingContextHelper.narrow(contextRef);
        NameComponent[] path = {new NameComponent("Adder","")};
        ctx.rebind(path,adder);
	System.out.println("Adder is bount.");
	System.out.println("Press <Enter> to terminate.");
        System.in.read();
        ctx.unbind(path);
        orb.disconnect(adder);
        orb.destroy();
    }

}
