import java.net.*;
import java.io.*;

public class Client {
   public static void main( String[] args ) throws IOException {
      Socket s = new Socket(args[0],1234);
      try {
         ObjectOutputStream out = new ObjectOutputStream(s.getOutputStream());
         ObjectInputStream in = new ObjectInputStream(s.getInputStream());
         for( int i=1; i<args.length; i++ ){
            out.writeUTF("add"); 
            out.writeInt(Integer.parseInt(args[i]));
            out.flush();
            out.writeUTF("get"); out.flush();
            int num = in.readInt();
            System.out.println(num);
         }
         out.writeUTF("close");
         out.flush();
      } finally {
         s.close();
      }
   }
}
