import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
public class CallerImpl extends UnicastRemoteObject implements Caller {

  CallMeBack cmb = null;
  Vector cmbs = new Vector();

  public void register( CallMeBack cmb ) {
    cmbs.add(cmb);
  }

  public void deregister( CallMeBack cmb ) {
    cmbs.remove(cmb);
  }

  void call(){
    Enumeration enum = cmbs.elements();
    while ( enum.hasMoreElements() )
       try { ((CallMeBack)enum.nextElement()).callMeBack(); } catch ( Exception e ){ e.printStackTrace(); }
  }

  public CallerImpl() throws RemoteException {}

  public static void main( String[] args ) throws Exception {
     CallerImpl caller = new CallerImpl();
     Naming.rebind("rmi://localhost/caller",caller);
     while( true ){
        Thread.sleep(3000);
        caller.call();
     }
  }

}
