import java.awt.*;
import java.rmi.*;
import java.rmi.server.*;

public class UI extends java.applet.Applet {

    Label label = new Label("");
    String serverName;
    CallMeBackImpl cmb; 

    public void init(){
        add(label);
        serverName = getParameter("server");
        label.setText(serverName);
        try{
           cmb = new CallMeBackImpl(label,getCodeBase().getHost()+"/"+serverName);
        } catch ( Exception e ){
           label.setText(e.toString()); 
           e.printStackTrace(); 
        }
    }

    public void start(){
        cmb.start();
    }

    public void stop(){
        cmb.stop();
    }

}