import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

public class Cart extends HttpServlet {

   protected void doGet ( HttpServletRequest req, HttpServletResponse res )
   throws ServletException, IOException {
       HttpSession session = req.getSession(false);   
       res.setContentType("text/html");
       res.setHeader("pragma", "no-cache");
       PrintWriter out = res.getWriter();
       out.print ( "<HTML><HEAD><TITLE>Online Shop</TITLE>" );
       out.print ( "</HEAD><BODY><FORM METHOD=POST ACTION=" );
       out.print ( res.encodeURL( req.getRequestURI() ) );
       out.print ( "><INPUT TYPE=SUBMIT NAME=foo " );
       out.print ( "VALUE=\"Put a FOO into the shopping cart\">" );
       out.print ( "<INPUT TYPE=SUBMIT NAME=bar " );
       out.print ( "VALUE=\"Put a BAR into the shopping cart\">" );
       out.print ( "<INPUT TYPE=SUBMIT NAME=see " );
       out.print ( "VALUE=\"See the shopping cart contents\">" );
       out.print ( "<INPUT TYPE=SUBMIT NAME=buy " );
       out.print ( "VALUE=\"Buy the shopping cart contents\">" );
       out.print ( "</FORM></BODY></HTML> " );
       out.close();
   } 

   protected void doPost ( HttpServletRequest req, HttpServletResponse res )
   throws ServletException, IOException {
      HttpSession session = req.getSession(true);
      if ( session.isNew() ) {
         session.setAttribute( "foo",  new int[] {0} );
         session.setAttribute( "bar",  new int[] {0} );
      }
      int[] foo = (int[]) session.getAttribute("foo");
      int[] bar = (int[]) session.getAttribute("bar"); 
      String msg = feldolgoz(req,session,foo,bar);
      vlaszol(req,res,msg);
   } 

   private String feldolgoz ( HttpServletRequest req, HttpSession session, 
                              int[] foo, int[] bar )
   throws ServletException, IOException {
      if ( req.getParameter("foo") != null ) {
         ++ foo[0];
         return "Bought a FOO. You now have " + foo[0] + ".";
      } else if ( req.getParameter("bar") != null ) {
         ++ bar[0];
         return "Bought a BAR. You now have " + bar[0] + ".";
      } else if ( req.getParameter("buy") != null ) {
         session.invalidate();
         return "Your order for " + foo[0] + " FOOs and " +
                bar[0] + " BARs has been accepted. " + 
                "Your shopping cart is empty now.";
      } else {
         return "You have " + foo[0] + " FOOs and " +
                bar[0] + " BARs in your shopping cart.";
      }
   } 

   private void vlaszol ( HttpServletRequest req, HttpServletResponse res, String msg )        
   throws ServletException, IOException {
       res.setContentType("text/html");
       res.setHeader("pragma", "no-cache");
       PrintWriter out = res.getWriter();
       out.print("<HTML><HEAD><TITLE>Shopping Cart</TITLE></HEAD><BODY>");
       out.print(msg);
       out.print("<HR><A HREF=\"");
       out.print( res.encodeURL( req.getRequestURI() ) );
       out.print("\">Back to the shop</A></BODY></HTML>");
       out.close(); 
   } 

   public String getServletInfo(){
      return "Hello servlet by Tams Kozsik";
   }

}

